Debian Bug report logs - #621763
dpkg-deb: unparseable error string, probably typo

version graph

Package: dpkg; Maintainer for dpkg is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg is src:dpkg.

Reported by: Otto Visser <o.w.visser@tudelft.nl>

Date: Fri, 8 Apr 2011 16:00:35 UTC

Severity: minor

Tags: patch

Found in version dpkg/1.16.0.1

Fixed in version dpkg/1.16.5

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#621763; Package dpkg. (Fri, 08 Apr 2011 16:00:41 GMT) Full text and rfc822 format available.

Acknowledgement sent to Otto Visser <o.w.visser@tudelft.nl>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 08 Apr 2011 16:00:42 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Otto Visser <o.w.visser@tudelft.nl>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dpkg-deb: unparseable error string, probably typo
Date: Fri, 08 Apr 2011 17:17:56 +0200
Package: dpkg
Version: 1.16.0.1
Severity: minor

While attempting to install an update to skype I got this output:

dpkg -i /local/downloads/skype-debian_2.2.0.25-1_amd64.deb 
(Reading database ... 194818 files and directories currently installed.)
Preparing to replace skype 2.1.0.81-1 (using
.../skype-debian_2.2.0.25-1_amd64.deb) ...
Unpacking replacement skype ...
dpkg-deb (subprocess): short read on buffer copy for failed to write to
pipe in copy
dpkg-deb: error: subprocess paste returned error exit status 2
dpkg: error processing
/local/downloads/skype-debian_2.2.0.25-1_amd64.deb (--install):
 short read on buffer copy for backend dpkg-deb during
 `./usr/share/skype/lang/skype_ja.qm'
 Processing triggers for desktop-file-utils ...
 Errors were encountered while processing:
  /local/downloads/skype-debian_2.2.0.25-1_amd64.deb

The sentence "short read on buffer copy for failed to write to                                             
pipe in copy" is a bit hard to parse... My guess here is that 'for'
should have been 'or'?


-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32 (SMP w/8 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages dpkg depends on:
ii  coreutils               8.5-1            GNU core utilities
ii  libbz2-1.0              1.0.5-6          high-quality block-sorting file co
ii  libc6                   2.11.2-13        Embedded GNU C Library: Shared lib
ii  libselinux1             2.0.98-1         SELinux runtime shared libraries
ii  xz-utils                5.0.0-2          XZ-format compression utilities
ii  zlib1g                  1:1.2.3.4.dfsg-3 compression library - runtime

dpkg recommends no packages.

Versions of packages dpkg suggests:
ii  apt                           0.8.13.2   Advanced front-end for dpkg

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#621763; Package dpkg. (Fri, 08 Apr 2011 23:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 08 Apr 2011 23:48:04 GMT) Full text and rfc822 format available.

Message #10 received at 621763@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Otto Visser <o.w.visser@tudelft.nl>, 621763@bugs.debian.org
Subject: Re: Bug#621763: dpkg-deb: unparseable error string, probably typo
Date: Sat, 9 Apr 2011 01:44:17 +0200
tag 621763 + patch
thanks

On Fri, 08 Apr 2011, Otto Visser wrote:
> dpkg-deb (subprocess): short read on buffer copy for failed to write to
> pipe in copy
> dpkg-deb: error: subprocess paste returned error exit status 2
> dpkg: error processing
> /local/downloads/skype-debian_2.2.0.25-1_amd64.deb (--install):
>  short read on buffer copy for backend dpkg-deb during
>  `./usr/share/skype/lang/skype_ja.qm'
>  Processing triggers for desktop-file-utils ...
>  Errors were encountered while processing:
>   /local/downloads/skype-debian_2.2.0.25-1_amd64.deb
> 
> The sentence "short read on buffer copy for failed to write to 
> pipe in copy" is a bit hard to parse... My guess here is that 'for'
> should have been 'or'?

No, actually the part "failed to write to pipe in copy" is wrong, it's
supposed to be an action description and not a complete error message.
That's because the actuel error message is constructed from 2 separate
strings.

Anyway, I have always found those error messages very hard to grasp
and badly worded. I took this opportunity to improve all those that
are related to buffer_copy().

Attached is a patch. Reviews welcome (including from translators since I
quite some strings).

With my patch, your error message would have been:
dpkg-deb (subprocess): unexpected end of input while copying ar member 'data.tar' from '/local/downloads/skype-debian_2.2.0.25-1_amd64.deb' to decompressor

At least you have a chance to guess that your .deb file was truncated and
is not complete.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Follow my Debian News ▶ http://RaphaelHertzog.com (English)
                      ▶ http://RaphaelHertzog.fr (Français)




Added tag(s) patch. Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Fri, 08 Apr 2011 23:48:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#621763; Package dpkg. (Sat, 09 Apr 2011 08:21:21 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 09 Apr 2011 08:21:26 GMT) Full text and rfc822 format available.

Message #17 received at 621763@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Raphael Hertzog <hertzog@debian.org>, 621763@bugs.debian.org
Subject: Re: Bug#621763: dpkg-deb: unparseable error string, probably typo
Date: Sat, 9 Apr 2011 10:07:36 +0200
Hi!

On Sat, 2011-04-09 at 01:44:17 +0200, Raphael Hertzog wrote:
> Anyway, I have always found those error messages very hard to grasp
> and badly worded.

Yeah, the "buffer api" in general has not been the pretiest thing.

> I took this opportunity to improve all those that are related to
> buffer_copy().

> Attached is a patch. Reviews welcome (including from translators since I
> quite some strings).

> With my patch, your error message would have been:
> dpkg-deb (subprocess): unexpected end of input while copying ar member 'data.tar' from '/local/downloads/skype-debian_2.2.0.25-1_amd64.deb' to decompressor
> 
> At least you have a chance to guess that your .deb file was truncated and
> is not complete.

It seems the patch didn't get attached, but AFAICS it's this one:

  <http://git.debian.org/?p=users/hertzog/dpkg.git;a=commitdiff;h=662fb936>

While I think the new strings in general are an improvement, if the
api requires to annotate every call site for the translators then IMO
the api itself is not adequate.

So, let me finish and push my changes to the buffer api, and then we
revisit this after that, ok?

thanks,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#621763; Package dpkg. (Sat, 09 Apr 2011 08:21:35 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 09 Apr 2011 08:21:36 GMT) Full text and rfc822 format available.

Message #22 received at 621763@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Guillem Jover <guillem@debian.org>
Cc: 621763@bugs.debian.org
Subject: Re: Bug#621763: dpkg-deb: unparseable error string, probably typo
Date: Sat, 9 Apr 2011 10:17:24 +0200
On Sat, 09 Apr 2011, Guillem Jover wrote:
> It seems the patch didn't get attached, but AFAICS it's this one:
> 
>   <http://git.debian.org/?p=users/hertzog/dpkg.git;a=commitdiff;h=662fb936>

Indeed.

> While I think the new strings in general are an improvement, if the
> api requires to annotate every call site for the translators then IMO
> the api itself is not adequate.

Yeah. We can fix that by making the 2 strings really independant but you
actually switched that from "<error> (<desc>)" to "<error> for <desc>".

The former was better to avoid weird-sounding sentences. Maybe we should
rather make it: "<desc>: <error>" to first set the context and then
describe the error.

> So, let me finish and push my changes to the buffer api, and then we
> revisit this after that, ok?

Ok. Just don't let me distract you too much from the goal of merging
multi-arch (I know the buffer api changes are part of preliminary changes
required for further cleaning of the multiarch branch though).

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Follow my Debian News ▶ http://RaphaelHertzog.com (English)
                      ▶ http://RaphaelHertzog.fr (Français)




Added tag(s) pending. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Sat, 30 Jun 2012 04:57:22 GMT) Full text and rfc822 format available.

Message sent on to Otto Visser <o.w.visser@tudelft.nl>:
Bug#621763. (Sat, 30 Jun 2012 04:57:39 GMT) Full text and rfc822 format available.

Message #27 received at 621763-submitter@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 621763-submitter@bugs.debian.org
Subject: Bug#621763 marked as pending
Date: Sat, 30 Jun 2012 04:53:59 +0000
tag 621763 pending
thanks

Hello,

Bug #621763 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=bd0da28

---
commit bd0da280d1b888b8709434ec405d1e8d33561756
Author: Guillem Jover <guillem@debian.org>
Date:   Tue May 10 20:02:28 2011 +0200

    libdpkg: Switch buffer I/O code to use struct dpkg_error
    
    As a side effect this mkes the messages more clear as the caller has
    more context to describe the error conditions.
    
    Closes: #621763

diff --git a/debian/changelog b/debian/changelog
index 97c771e..db00a4c 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -36,6 +36,7 @@ dpkg (1.16.5) UNRELEASED; urgency=low
     replace the now deprecated --control-path.
   * Print master and slave alternarive link names in update-alternatives
     --query and always print alternative link in --config. Closes: #679010
+  * Cleanup and clarify buffer I/O error reporting. Closes: #621763
 
   [ Updated dpkg translations ]
   * Swedish (Peter Krefting).




Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Sat, 30 Jun 2012 05:21:10 GMT) Full text and rfc822 format available.

Notification sent to Otto Visser <o.w.visser@tudelft.nl>:
Bug acknowledged by developer. (Sat, 30 Jun 2012 05:21:10 GMT) Full text and rfc822 format available.

Message #32 received at 621763-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 621763-close@bugs.debian.org
Subject: Bug#621763: fixed in dpkg 1.16.5
Date: Sat, 30 Jun 2012 05:17:51 +0000
Source: dpkg
Source-Version: 1.16.5

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.16.5_all.deb
  to main/d/dpkg/dpkg-dev_1.16.5_all.deb
dpkg_1.16.5.dsc
  to main/d/dpkg/dpkg_1.16.5.dsc
dpkg_1.16.5.tar.xz
  to main/d/dpkg/dpkg_1.16.5.tar.xz
dpkg_1.16.5_amd64.deb
  to main/d/dpkg/dpkg_1.16.5_amd64.deb
dselect_1.16.5_amd64.deb
  to main/d/dpkg/dselect_1.16.5_amd64.deb
libdpkg-dev_1.16.5_amd64.deb
  to main/d/dpkg/libdpkg-dev_1.16.5_amd64.deb
libdpkg-perl_1.16.5_all.deb
  to main/d/dpkg/libdpkg-perl_1.16.5_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 621763@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 30 Jun 2012 04:28:51 +0200
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.16.5
Distribution: unstable
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 64642 440094 558095 621763 624000 627333 640676 643043 652970 664058 672723 673190 675333 676232 677631 678933 679010
Changes: 
 dpkg (1.16.5) unstable; urgency=low
 .
   [ Raphaël Hertzog ]
   * dpkg-source will now clean up after a failed application of a quilt
     patch. Closes: #652970
     And it will display a message explaining the most likely cause of
     failure (patch applying with fuzz).
   * When dpkg-source regenerates the automatic patch (with formats "2.0"
     or "3.0 (quilt)") it will keep the current patch header to avoid
     losing changes made by the maintainer.
   * Modify dpkg-source --commit to auto-whitelist modified binary files.
     That way the same command can be used whatever kind of upstream files
     has been modified.
   * dpkg-source now supports a new option --no-unapply-patches to force
     patches to be kept applied after build (used by formats "2.0" and "3.0
     (quilt)"). Closes: #643043
 .
   [ Guillem Jover ]
   * Add a dpkg-buildflags --status action to describe the flag settings.
     Thanks to Bernhard R. Link <brlink@debian.org>. Closes: #664058
   * Add support for “binary-only” key-value option in changelogs, to allow
     marking changelog entries as part of a binary only upload, having a
     different version from the source package. Closes: #440094, #672723
   * Minimize source architecture list on «dpkg-source -b» by removing
     architectures already covered by architecture wildcards. Closes: #675333
   * Do not assume $ENV{'HOME'} is defined in Dpkg::Source::Package.
     Thanks to Niels Thykier <niels@thykier.net>. Closes: #677631
   * Document in more detail in deb(5) the supported ar archive format.
   * Document in deb-src-control(5) the “Private-” field prefix.
   * Add new start-stop-daemon --no-close option to disable closing file
     descriptors on --background. Closes: #627333, #64642
   * Switch source compression to xz.
   * Detect ar header fields truncation due to too long member names or too
     large member sizes. Closes: #678933
   * Add new dpkg-query --control-list and --control-show commands, which
     replace the now deprecated --control-path.
   * Print master and slave alternarive link names in update-alternatives
     --query and always print alternative link in --config. Closes: #679010
   * Cleanup and clarify buffer I/O error reporting. Closes: #621763
   * Avoid full stop and double newline at the end of errors and warnings.
     Thanks to Jonathan Nieder <jnieder@gmail.com>. Closes: #624000
   * Change all programs to accept -? instead of -h for help output.
   * Add support for specific arch-qualified dependencies. Closes: #676232
     Thanks to Thibaut Girka <thib@sitedethib.com>.
   * Accept “:native” arch-qualified Build-Dependencies. Closes: #558095
     Thanks to Thibaut Girka <thib@sitedethib.com>.
   * Do not use undefined values returned form deps_parse() in dpkg-shlibdeps.
     Closes: #640676
   * Add an Architecture column to «dpkg-query -l» before the Description
     column. Suggested by Jonathan Nieder <jnieder@gmail.com>. Closes: #673190
 .
   [ Updated dpkg translations ]
   * Swedish (Peter Krefting).
 .
   [ Updated dselect translations ]
   * Swedish (Peter Krefting).
 .
   [ Updated scripts translations ]
   * German (Helge Kreutzmann).
 .
   [ Updated man page translations ]
   * German (Helge Kreutzmann).
   * Swedish (Peter Krefting).
Checksums-Sha1: 
 5e256018148d50da61a19da0cbce49f65cd03169 1372 dpkg_1.16.5.dsc
 e3aaf08015bab5c40980f36514152102556b76b2 3546160 dpkg_1.16.5.tar.xz
 d826663e329d140f38ddfc4353b937cb270c6688 666932 libdpkg-dev_1.16.5_amd64.deb
 c078e1861151da90049e7ce788cb513b769e2e0f 2266848 dpkg_1.16.5_amd64.deb
 ea065b58a7aa49771a275e4e26a7603b65becadf 1100228 dselect_1.16.5_amd64.deb
 c1e214b79282fb56eaa54ad8f2a1dc2daad64eef 1142828 dpkg-dev_1.16.5_all.deb
 085f8ee024365882d641e60e209cc3bfca43bd36 852954 libdpkg-perl_1.16.5_all.deb
Checksums-Sha256: 
 3a4eec53e585abcb15c71f08331da63610150f4858793bc68ee2df006d1da8a6 1372 dpkg_1.16.5.dsc
 fcd8d846479f3f955e1f1facc4422aed6c3173b6c5acd904d9db60f24bc18e7b 3546160 dpkg_1.16.5.tar.xz
 aba88af2256caef0fdd345ba9eeacff8d2013a07b045d5b7c93162bd0893c10b 666932 libdpkg-dev_1.16.5_amd64.deb
 1a56e13f5fc11eabb5ea7d17852cb1b3b09a117b16803e5b9a64ec14b3f37a62 2266848 dpkg_1.16.5_amd64.deb
 50ac49b8115e6d19148031ecec7f976c69a084504c42b860abd1470e63b1f5d0 1100228 dselect_1.16.5_amd64.deb
 7a23dd256195eec9f1ce2297737747a27a8c6d3beba5c9e8e9ac8d8734f07f54 1142828 dpkg-dev_1.16.5_all.deb
 d77dc62deb89a923952c533b2320130d9573e8c3ebfa09fbdf80c835ca30ef65 852954 libdpkg-perl_1.16.5_all.deb
Files: 
 571bd79d38407d605f7559cf65347c01 1372 admin required dpkg_1.16.5.dsc
 c70412c8b0f3609680104585ddb4ba5c 3546160 admin required dpkg_1.16.5.tar.xz
 49221981d6f3490ddc87c8a03bbe332d 666932 libdevel optional libdpkg-dev_1.16.5_amd64.deb
 d9128c702529b095fda97b205bf03398 2266848 admin required dpkg_1.16.5_amd64.deb
 3eed99660309c9fba61b490c057deb78 1100228 admin optional dselect_1.16.5_amd64.deb
 3c7266174c297984846a6eb88ae3730f 1142828 utils optional dpkg-dev_1.16.5_all.deb
 848633279951281c6213f877251081e3 852954 perl optional libdpkg-perl_1.16.5_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAk/uhA4ACgkQuW9ciZ2SjJvLqACgvBBdkE81qC2iEsdk4lhVoilv
hd8AoI/JlSVaR2i+DU9dLBBvCWo9RvWC
=xtFu
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 20 Aug 2012 07:27:48 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 13:20:30 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.